PluginResolveEngine (Grails 2.4.4)
Date: 2014-10-28

Package: org.codehaus.groovy.grails.resolve

## [Groovy] Class PluginResolveEngine

- org.codehaus.groovy.grails.resolve.PluginResolveEngine

- Utility methods for resolving plugin zips and information used in conjunction with an IvyDependencyManager instance.

  Authors:
    Graeme Rocher
  Since:
    1.3

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `DependencyManager` | `dependencyManager`
    `groovy.lang.Closure` | `messageReporter`
    `BuildSettings` | `settings`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `PluginResolveEngine (DependencyManager dependencyManager, BuildSettings settings)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `DependencyManager` | `createFreshDependencyManager()`
    `java.lang.Object` | `createResolveArguments(java.lang.String pluginName, java.lang.String pluginVersion)`
    `protected java.lang.String` | `getPluginInfoFooter()`
    `protected java.lang.String` | `getPluginInfoHeader()`
    `protected void` | `printDependencies(java.lang.Object output, java.lang.Object dependencies)`
    `protected void` | `printLineSeparator(java.io.PrintWriter output)`
    `protected void` | `printSectionTitle(java.io.PrintWriter output, java.lang.String title)`
    `void` | `renderInstallInfo(java.lang.String pluginName, java.lang.String version, java.io.Writer writer)`
    `groovy.util.slurpersupport.GPathResult` | `renderPluginInfo(java.lang.String pluginName, java.lang.String pluginVersion, java.io.OutputStream outputStream)` Renders plugin info to the target writer
    `groovy.util.slurpersupport.GPathResult` | `renderPluginInfo(java.lang.String pluginName, java.lang.String pluginVersion, java.io.Writer writer)` Renders plugin info to the target writer
    `groovy.util.slurpersupport.GPathResult` | `resolvePluginMetadata(java.lang.String pluginName, java.lang.String pluginVersion)` This method will resolve the plugin.xml file for a given plugin without downloading the plugin zip itself
    `java.io.File` | `resolvePluginZip(java.lang.String pluginName, java.lang.String pluginVersion, java.lang.String scope = "", java.util.Map args = [:])` Resolve a Plugin zip for for the given name and plugin version

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Property Detail

    - #### DependencyManager dependencyManager

    - #### groovy.lang.Closure messageReporter

    - #### BuildSettings settings

  - ### Constructor Detail

    - #### PluginResolveEngine(DependencyManager dependencyManager, BuildSettings settings)

  - ### Method Detail

    - #### DependencyManager createFreshDependencyManager()

    - #### java.lang.Object createResolveArguments(java.lang.String pluginName, java.lang.String pluginVersion)

    - #### protected java.lang.String getPluginInfoFooter()

    - #### protected java.lang.String getPluginInfoHeader()

    - #### protected void printDependencies(java.lang.Object output, java.lang.Object dependencies)

    - #### protected void printLineSeparator(java.io.PrintWriter output)

    - #### protected void printSectionTitle(java.io.PrintWriter output, java.lang.String title)

    - #### void renderInstallInfo(java.lang.String pluginName, java.lang.String version, java.io.Writer writer)

    - #### groovy.util.slurpersupport.GPathResult renderPluginInfo(java.lang.String pluginName, java.lang.String pluginVersion, java.io.OutputStream outputStream)

      Renders plugin info to the target writer

      Parameters:
        `pluginName` - The plugin name
        `pluginVersion` - The plugin version
        `output` - The target writer

    - #### groovy.util.slurpersupport.GPathResult renderPluginInfo(java.lang.String pluginName, java.lang.String pluginVersion, java.io.Writer writer)

      Renders plugin info to the target writer

      Parameters:
        `pluginName` - The plugin name
        `pluginVersion` - The plugin version
        `output` - The target writer

    - #### groovy.util.slurpersupport.GPathResult resolvePluginMetadata(java.lang.String pluginName, java.lang.String pluginVersion)

      This method will resolve the plugin.xml file for a given plugin without downloading the plugin zip itself

    - #### java.io.File resolvePluginZip(java.lang.String pluginName, java.lang.String pluginVersion, java.lang.String scope = "", java.util.Map args = [:])

      Resolve a Plugin zip for for the given name and plugin version

      Parameters:
        `pluginName` - The plugin name
        `pluginVersion` - The plugin version
      Returns:
        The location of the local file or null if an error occured